﻿if not HyperFederales then

	HyperFederales = ModInstance
	HyperFederales.save_path = SavePath .. "hyper_federales.json"
	HyperFederales.settings = {
		remove_shield = false
	}

	Hooks:Add("LocalizationManagerPostInit", "hyper_federales_LocalizationManagerPostInit", function(loc)
		loc:add_localized_strings({
			hyper_federales_menu_main = "Hyper Federales",
			hyper_federales_menu_main_desc = "Settings require a full game restart to take effect after toggling.",
			hyper_federales_menu_remove_shield = "Remove Shield",
			hyper_federales_menu_remove_shield_desc = "When enabled, removes the model and textures of the Shields' shield. Requires full game restart.",
		})
	end)

	Hooks:Add("MenuManagerBuildCustomMenus", "hyper_federales_MenuManagerBuildCustomMenus", function(_, nodes)

		local menu_id = "hyper_federales_menu"
		MenuHelper:NewMenu(menu_id)

		function MenuCallbackHandler:hyper_federales_setting_toggle(item)
			HyperFederales.settings[item:name()] = (item:value() == "on")
		end

		function MenuCallbackHandler:hyper_federales_save()
			io.save_as_json(HyperFederales.settings, HyperFederales.save_path)
		end

		MenuHelper:AddToggle({
			id = "remove_shield",
			title = "hyper_federales_menu_remove_shield",
			desc = "hyper_federales_menu_remove_shield_desc",
			callback = "hyper_federales_setting_toggle",
			value = HyperFederales.settings.remove_shield,
			menu_id = menu_id,
		})

		nodes[menu_id] = MenuHelper:BuildMenu(menu_id, {back_callback = "hyper_federales_save"})
		MenuHelper:AddMenuItem(nodes["blt_options"], menu_id, "hyper_federales_menu_main")

	end)

	--Load settings
	if io.file_is_readable(HyperFederales.save_path) then
		local data = io.load_as_json(HyperFederales.save_path)
		if data then
			local function merge(tbl1, tbl2)
				for k, v in pairs(tbl2) do
					if type(tbl1[k]) == type(v) then
						if type(v) == "table" then
							merge(tbl1[k], v)
						else
							tbl1[k] = v
						end
					end
				end
			end
			merge(HyperFederales.settings, data)
		end
	end

	local asset_loader = HyperFederales:GetSuperMod():GetAssetLoader()

	asset_loader:LoadAssetGroup("main")

	if not HyperFederales.settings.remove_shield then
		asset_loader:LoadAssetGroup("shield_model")
	end
end
